﻿namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private
    ////////////////////////////////////////////////////////////////////// Event

    #region 클라이언트 메시지 도착시 처리하기 - client_MessageArrived(sender, message)

    /// <summary>
    /// 클라이언트 메시지 도착시 처리하기
    /// </summary>
    /// <param name="sender">이벤트 발생자</param>
    /// <param name="message">이벤트 인자</param>
    private static void client_MessageArrived(object sender, ResponseMessage message)
    {
        Console.Write(message.Response);

        if(message.Done)
        {
            Console.WriteLine();
        }
    }

    #endregion

    ////////////////////////////////////////////////////////////////////// Function

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    /// <returns>태스크</returns>
    static async Task Main()
    {
        using APIClient client = new APIClient();

        client.MessageArrived += client_MessageArrived;

        RequestMessage requestMessage = new() { Model = "llama3", Prompt = "Hello, how are you?" };

        List<ResponseMessage> responseMessageList = await client.RequestChatStreamAsync(requestMessage);

        Console.WriteLine($"응답 메시지 건수 : {responseMessageList.Count}");
    }

    #endregion
}